import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.measure.*;
import ij.plugin.TextReader;
import java.io.File;
import java.lang.*;
import ij.io.*;

import ij.ImagePlus;
import ij.ImageStack;
import ij.gui.GenericDialog;
import ij.gui.Plot;
import ij.plugin.filter.PlugInFilter;
import ij.process.Blitter;
import ij.process.FloatProcessor;
import ij.process.ImageProcessor;
import snakeprogram.MultipleSnakesStore;
import snakeprogram.Snake;
import snakeprogram.SnakeIO;

import java.awt.*;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;

import java.io.*;
import java.util.*;
import java.lang.Math;
import java.text.*;

public class Crosscor_2D implements PlugInFilter {
  
  ImagePlus imp;
  double LINE_WIDTH;
  
  int npts = 1; //number of time points/frames
  double dt = 1; //time per frame
  int strt = 1; //the first angle for analysis
  int ntheta = 1; //the number of angles to analyze
  
  double[][] matrix1 = new double[360][500];
  double[][] matrix2 = new double[360][500];
  int row = 0, column = 0;
  int columnCount=0;
  
  double[] mx = new double[400];
  double[] my = new double[400];
  double[][] result = new double[1001][1001];
  double nn;
  double denom1 = 0, denom2 = 0, denom = 0;
  
  //new variables
  int dth = 0;
  int[] mi = new int[400];
  
  public int setup(String arg, ImagePlus imp) {
    this.imp = imp;
    return DOES_ALL;
  }
  
  public void run(ImageProcessor ip) {
    
    int maxF=0;
    GenericDialog gd = new GenericDialog("Constants");
    // read in the width of the kymograph ribbon and cell center
    LINE_WIDTH=4;
    gd.addNumericField("N, number of frames:", npts, 2);
    gd.addNumericField("dt, time per frame (s): ", dt, 2);
    gd.addNumericField("\u03B8 min,  minimum angle for averaging (degrees): ", strt, 2);
    gd.addNumericField("M, the number of angles to analyze: ", ntheta, 2);
    gd.showDialog();
   
    
    if (gd.wasCanceled())
      return;
    
    npts = (int)gd.getNextNumber() - 1;
    dt = (int)gd.getNextNumber();
    strt = (int)gd.getNextNumber();
    ntheta = (int)gd.getNextNumber();
    
    for (int i = 0; i<1001; i++)
      for (int j = 0; j<1001; j++)
        result[i][j] = 0;
    
    // read in the snake file
    OpenDialog od = new OpenDialog("First file for analysis:", null);
    String dir1 = od.getDirectory() + od.getFileName();
    try
    {
      BufferedReader in = new BufferedReader(new FileReader(dir1)); //reading files in specified directory
      
      String line;
      while ((line = in.readLine()) != null) //file reading
      {
        String[] values = line.split("\\s");
        for (String str : values)
        {
          double str_double = Double.parseDouble(str);
          double round_double = Math.round(str_double*1000000.0)/1000000.0;
          matrix1[row][column]=round_double;
          column = column+1;
        }
        row = row+1;
        columnCount = column;
        column = 0;
      }
      in.close();
    }catch( IOException ioException ) {}
    //whether check file number of columns and rows --------------------?
    
    od = new OpenDialog("First file for analysis:", null);
    String dir2 = od.getDirectory() + od.getFileName();
    row = 0;
    column = 0;
    try
    {
      BufferedReader in = new BufferedReader(new FileReader(dir2));
      
      String line;
      while ((line = in.readLine()) != null)
      {
        String[] values = line.split("\\s");
        for (String str : values)
        {
          double str_double = Double.parseDouble(str);
          double round_double = Math.round(str_double*1000000.0)/1000000.0;
          matrix2[row][column]=round_double;
          column = column+1;
        }
        row = row+1;
        column = 0;
      }
      in.close();
    }catch( IOException ioException ) {}
    
    //calculate result    
    //compute average
    for (dth = -ntheta; dth <= ntheta; dth++){
      for (int th = strt; th < (strt+ntheta+1); th++){
        mx[th] = 0;
        my[th] = 0;
        mi[th] = 0;
        for (int i=1; i<npts+1; i++){
          if ((dth+th-strt)>=0 && (dth+th-strt)<=ntheta){
            mx[th] += matrix1[th][i];
            my[th] += matrix2[th+dth][i];
            mi[th]++;
          }
        }
        my[th] /= mi[th];
        mx[th] /= mi[th];
      }
         
      //crosscor
      for (int th=strt; th<(strt+ntheta+1); th++){
        denom1 = 0;
        denom2 = 0;
        for (int i=1; i<npts+1; i++){
          if ((dth+th-strt)>=0 && (dth+th-strt)<=ntheta){
            denom1 += (matrix1[th][i] - mx[th])*(matrix1[th][i] - mx[th])/mi[th];
            denom2 += (matrix2[th+dth][i] - my[th])*(matrix2[th+dth][i] - my[th])/mi[th];
          }
        }
        denom = Math.round(((mi[th])*(Math.sqrt(denom1))*(Math.sqrt(denom2)))*1000000.0)/1000000.0;
        
        for (int n = -npts; n <= npts; n++){
          for (int m = 0; m < npts; m++){
            if ((n+m)>=0 && (n+m)<npts && (dth+th-strt)>=0 && (dth+th-strt)<=ntheta){
              result[dth+ntheta][n+npts] += ((matrix1[th][m+1] - mx[th])*(matrix2[th+dth][m+n+1] - my[th]))/(denom);
              
            }
          }
        }
        
      }      
    }  
    
    od = new OpenDialog("Select a directory to save result file", null, "CrossCor_2DResult.txt");
    String dir3 = od.getDirectory() + od.getFileName();
    File f = new File(dir3);
    int bool = 1;
    //loop for checking whether the file exists and whether user wants to replace it
    while (f.exists()&&bool==1){
      gd = new GenericDialog("WARNING");
      gd.addMessage("There is already a file with the same name in this location. \nDo you want to replace the old file with the new one?");
      gd.enableYesNoCancel();
      gd.showDialog();
    
      if (gd.wasCanceled())
        return;
      else if (gd.wasOKed())
        bool = 0;
      else{
        od = new OpenDialog("Select a directory to save result file", od.getLastDirectory(),null);
        dir3 = od.getDirectory() + od.getFileName();
        f = new File(dir3);
      }
    }
    
    //write a result file
    File file = new File(dir3);
    try {
      FileWriter file_writer = new FileWriter (file);
      BufferedWriter buf_writer = new BufferedWriter (file_writer);
      PrintWriter print_writer = new PrintWriter (buf_writer,true);
      
      for (dth = -ntheta; dth <= ntheta; dth++){
        for (int i=-npts;i<=npts;i++){
          DecimalFormat df = new DecimalFormat("0.000000");
          print_writer.print(df.format(result[dth+ntheta][i+npts]/(ntheta+1))+"\t");
        }
        print_writer.println("");
      }
      
      if (print_writer.checkError ()) {
        System.out.println ("An output error occurred!" );
      }
    }
    catch (IOException ioe){
      System.out.println("IO Exception");
    }
  }
}

