import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.measure.*;
import ij.plugin.TextReader;
import java.io.File;
import java.lang.*;
import ij.io.*;
import ij.ImagePlus;
import ij.ImageStack;
import ij.gui.GenericDialog;
import ij.gui.Plot;
import ij.plugin.filter.PlugInFilter;
import ij.process.Blitter;
import ij.process.FloatProcessor;
import ij.process.ImageProcessor;
import snakeprogram.MultipleSnakesStore;
import snakeprogram.Snake;
import snakeprogram.SnakeIO;

import java.awt.*;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;

import java.io.*;
import java.util.*;
import java.lang.Math;
import java.text.*;
import java.util.Random;
public class Speckle_Velocity implements PlugInFilter
{
  ImagePlus implus;
  double LINE_WIDTH;
  public static int top, bot;
  public static double dt;
  public static int tfit;
  public static int nvr;
  public static int N;
  public static double scaler=1.0;
    
  public static double dist = 0.0;
  public static double pi = 3.141592654;
  BufferedWriter bw;
  public int setup(String arg, ImagePlus implus) {
    this.implus = implus;
    return DOES_ALL;
  }
  
  public void run(ImageProcessor imp) 
  {
   
    double cx,cy,px,delt;    
    top = 360;
    bot = 0;
    tfit = 10;
    cx=0;
    cy=0;
    px=0;
    N=0;
    GenericDialog gf = new GenericDialog("Constants");
    gf.addNumericField("dx, image resolution (nm/px): ", px,2);
    gf.addNumericField("dt, time per frame (s): ", dt, 2);
    gf.addNumericField("M, number of frames for linear fit: ", tfit, 2);
    gf.addNumericField("N, number of frames (total): ", N, 2);
    gf.addNumericField("S, scale factor for vector flow diagram: ", scaler, 2);
    gf.showDialog();
    
    if (gf.wasCanceled())
        return;
      
  
    px = (int)gf.getNextNumber();
    dt = gf.getNextNumber();
    tfit = (int)gf.getNextNumber();
    N = (int)gf.getNextNumber();
    scaler = gf.getNextNumber();
    nvr = tfit*2+1;
    double[] x = new double[N];
    double[] y = new double[N];
    int[] pts = new int[N];
    int[] t = new int[N];
    // assuming max possible 500 speckles to be considered per frame
    double xf[][]=new double[N][500];
    double yf[][]=new double[N][500];
    double vxf[][]=new double[N][500];
    double vyf[][]=new double[N][500];
    int nspeck[]=new int [N];
     
    Arrays.fill(x,0.0);
    Arrays.fill(y,0.0);
    Arrays.fill(pts,0);
    Arrays.fill(t,0);
    Arrays.fill(nspeck,0);
    
    //pointers:
    double[][] rad = new double[361][361];
    double[][] nrad = new double[361][361];
    double[][] velM = new double[361][361];
    
    for (int i=0;i<360;i++){
      Arrays.fill(rad[i],0.0);
      Arrays.fill(nrad[i],0.0);
      Arrays.fill(velM[i],0.0);
    }
    
    //local variables
    int kd=0,ki=0,kk=0,ji=0,chk=0;
    int ii=0,jj=0;
    int pp=0,tt=0,f=0,p=0;
    int nfl=0, ni=0;
    int start=0;
    int numf=0;
    int[] nth = new int[400];
    int[] nd = new int[10];
    double[] vret = new double[10];
    double[] vret2 = new double[10];
    
    Arrays.fill(nth,0);
    Arrays.fill(nd,0);
    Arrays.fill(vret,0.0);
    Arrays.fill(vret2,0.0);
    
    int h = 2000;
    int w = 2000;
    int l = 2;
    int thS=0;
    double stime=0.0,z=0.0;
    double x1=0.0,x2=0.0,y1=0.0,y2=0.0;
    double distb = 0.0;
    double delx=0.0, dely=0.0, r=0.0, velr=0.0,velt=0.0;
    double velx, vely;
    double rx=0.0,rx2=0.0,ry=0.0,rt=0.0,rt2=0.0,rxt=0.0,ryt=0.0,ry2=0.0,mx=0.0,my=0.0,bx=0.0,by=0.0;
    double xx=0.0,yy=0.0,zz=0.0;
    double eb=0.0;
    
    //pointers:
    double[][][] snake = new double[200][300][3];
    double[][][] ssnake = new double[200][300][3];
    
    for (int i=0;i<100;i++){
      for (int j=0;j<100;j++){
        Arrays.fill(snake[i][j],0.0);
        Arrays.fill(ssnake[i][j],0.0);
      }
    }
    
    //other variables
    int column = 0, row = 0;
    
    //array for storing output
    String[] output = new String[20000];
    Arrays.fill(output,"");
    int outputCount = 0;
    
    //read in file    
    OpenDialog od = new OpenDialog("Leading Edge Velocity Matrix", null);
    String dir1 = od.getDirectory() + od.getFileName();
    try
    {
      BufferedReader in = new BufferedReader(new FileReader(dir1)); //reading files in specified directory
      
      String line;
      while ((line = in.readLine()) != null) //file reading
      {
        String[] values = line.split("\\s");
        for (String str : values)
        {
          if (!str.isEmpty()){
            double str_double = Double.parseDouble(str);
            double round_double = Math.round(str_double*1000000.0)/1000000.0;
            velM[column][row]=round_double;
            column = column+1;
          }
        }
        row = row+1;
        column = 0;
      }
      in.close();
    }catch( IOException ioException ) {}
    
    //read in the second file
    od = new OpenDialog("Snake file", null);
    String dir2 = od.getDirectory() + od.getFileName();
    row = 0;
    column = 0;
    boolean read = false;
    try
    {
      BufferedReader in = new BufferedReader(new FileReader(dir2));
      String line;
      
      while ((line = in.readLine()) != null)
      {    	 
    	  if(row>10) read = true;   		  
    	  String[] values = line.split("\t");		  
    		if(read){
    			
    			for (String str : values)
    			{
    			  if (column==0)
    				  f = Integer.parseInt(str);
    			  if (column==1)
    				  p = Integer.parseInt(str);
    			  if (column==2){
    				  xx = Double.parseDouble(str);
    			  }
    			  if (column==3)
    				  yy = Double.parseDouble(str);
    			  if (column==4)
    				  zz = Double.parseDouble(str);
    			  column++;
    		  }
    		  numf = f;
    		  f--;
    		  pts[f]++;
    		  snake[f][p][0] = xx-cx;
    		  snake[f][p][1] = yy-cy;
    	 
        }// end if read
        column = 0;
        row++;
      }
      in.close();
    }catch( IOException ioException ) {}
    
    //calculation before reading third file
    //Calculating before reading the third file...
    for(f=0;f<numf;f++)
    {
      Arrays.fill(nth,0);
      for(p=0;p<pts[f];p++)
      {
        xx = snake[f][p][0];
        yy = snake[f][p][1];
        snake[f][p][0] = Math.sqrt(xx*xx + yy*yy);
        snake[f][p][1] = Math.atan(yy/xx);
        snake[f][p][1] *= (180/Speckle_Velocity.pi);
        // shift to the correct quadrant...
        if(xx<0 && yy>0) 
          snake[f][p][1] += 180; 
        if(xx<0 && yy<0) 
          snake[f][p][1] += 180; 
        if(xx>0 && yy<0) 
          snake[f][p][1] += 360; 
        if(snake[f][p][1] < 0) 
          snake[f][p][1] += 360;
        tt = (int)snake[f][p][1];
        rad[f][tt] += snake[f][p][0];
        nth[tt]++;
      }
      
      for(int i=0;i<360;i++)
      {
        if(nth[i] > 0)
          rad[f][i] /= nth[i];
        
      }
      
      for(int i=0;i<360;i++)
      {
        // smooth out areas with no points
        if(rad[f][i]==0 && f>0 && f<numf && i>0)
          rad[f][i] = (rad[f][i+1]+rad[f][i-1])/2.0;
      }
    }
    // we now have an array, rad, which provides the radius of the leading edge at each angle, i, for time point, f
    
    // smooth the data, to minimize 'jittter' in the data
    for(f=1;f<numf-1;f++){
      for(int i=1;i<359;i++){        
        nrad[f][i] = rad[f-1][i-1] + rad[f-1][i] + rad[f-1][i+1];
        nrad[f][i] += rad[f][i-1] + rad[f][i] + rad[f][i+1];
        nrad[f][i] += rad[f+1][i-1] + rad[f+1][i] + rad[f+1][i+1];
        nrad[f][i] /= 9.0;
      }
    }
    
    for(f=1;f<numf-1;f++){
      for(int i=1;i<359;i++)
        rad[f][i] = nrad[f][i];
      
    }
    
    int countLine = 0;
    read = true;
    ji = 0;
    
    //read in the third file
    od = new OpenDialog("Speckle File", null);
    String dir3 = od.getDirectory() + od.getFileName();
    try
    {
      BufferedReader in = new BufferedReader(new FileReader(dir3)); //reading files in specified directory
      
      String line;
      while ((line = in.readLine()) != null) //file reading
      {
        String[] values = line.split("\t");
        for (String str : values)
        {
          if (column==0){
            if (countLine < 2 || str.equals("#%start speckle%") || str.equals("#%stop speckle%"))
              read = false;
            else
              read = true;
            
            if (read)
              x[ji] = Double.parseDouble(str);
          }
          if (column==1 && read)
            y[ji] = Double.parseDouble(str);
          if (column==2 && read)
            t[ji] = Integer.parseInt(str);
          column++;
        }
        if (read){//shift the data
          t[ji]--;
          x[ji] = x[ji] - cx;
          y[ji] = y[ji] - cy;
          ji++;
        }
        else if (!read && ji!= 0){// stop reading, now analyze this speckle
          ki++;
          dist = 0;
          
          thS = Speckle_Velocity.mindist(ji,t[0],x,y,t,rad); //get angle of speckle's position
                    
          dist *= px*1.0/1000; //put distance into microns
          
          if(thS > bot && thS < top){ // speckle is in range of angles we want (determined by snake)
            if(ji >= nvr){
              kk = ji;
              start =(int)(nvr/2);
              while(kk-nvr >= 0){
                ii = nvr/2;
                rt = 0;
                rt2 = 0;
                ry = 0;
                ryt = 0;
                rx = 0;
                rxt = 0;
                int nnn = 0;
                for(int i=start-ii;i<start+ii;i++)
                {
                  // sum up values for the averages
                  nnn++;
                  rt += t[i];
                  ry += y[i];
                  rx += x[i];
                  rt2 += t[i]*t[i];
                  rxt += x[i]*t[i];
                  ryt += y[i]*t[i];
                }
                
                //take average
                rt /= nnn;
                rx /= nnn;
                ry /= nnn;
                rt2 /= nnn;
                rxt /= nnn;
                ryt /= nnn;
                
                // calculate linear slope and intercepts for both x and y
                mx = (rxt-rx*rt)/(rt2-rt*rt);
                bx = rx-mx*rt;
                
                my = (ryt-ry*rt)/(rt2-rt*rt);
                by = ry-my*rt;
                
                // calculate x velocity
                x1 = mx*t[start-ii]+bx;
                x2 = mx*t[start+ii-1]+bx;
                delx = x2-x1;
                
                // calculate y velocity
                y1 = my*t[start-ii]+by;
                y2 = my*t[start+ii-1]+by;
                dely = y2-y1;
                
                velx = delx*px/(dt*(t[start+ii-1]-t[start-ii]));
                vely = dely*px/(dt*(t[start+ii-1]-t[start-ii]));
                velt = Math.sqrt(velx*velx+vely*vely);
                
                ii = t[start];
                xx = rad[ii][thS]*Math.cos(thS*Speckle_Velocity.pi/180);
                yy = rad[ii][thS]*Math.sin(thS*Speckle_Velocity.pi/180); 
                
                xx = xx-(mx*t[start]+bx);
                yy = yy-(my*t[start]+by);
                
                distb = Math.sqrt(xx*xx+yy*yy);
                distb *= px/1000;
                DecimalFormat df = new DecimalFormat("0.000000");
                output[outputCount] = " "+ki+" "+ ii +" " + dt*ji + " " +thS+" "+df.format(distb)+" "+  df.format(velM[ii][thS])+" "
                  +df.format(velt)+" "+df.format(velx)+" "+df.format(vely);
                outputCount++;
                
                jj = nspeck[ii];// number of speckles with velocities in this frame
                xf[ii][jj] = x[start];
                yf[ii][jj] = y[start];
                vxf[ii][jj] = velx;
                vyf[ii][jj] = vely;
                nspeck[ii]++;
                
                kk--;
                start++;
              }
            }
          }
          ji = 0;
        }
        column = 0;
        countLine++;
      }
      in.close();
    }catch( IOException ioException ) {}
    

    try{
    FileDialog fd = new FileDialog(ij.IJ.getInstance(),"Save Speckle File",FileDialog.SAVE);
    fd.setFile("SpeckleOutput.txt");
    fd.setVisible(true);
    String fname = fd.getFile();
    String dirname = fd.getDirectory();
    String outname = dirname +  fname;
    File file = new File(outname);
    FileWriter file_writer = new FileWriter (file);
    BufferedWriter buf_writer = new BufferedWriter (file_writer);
    PrintWriter print_writer = new PrintWriter (buf_writer,true);
    
  
    
    for(int i=0;i<20000;i++){
        if(!output[i].isEmpty()) print_writer.println(output[i]);
      }
  
    }catch(Exception e){
        System.out.println("problems");
       e.printStackTrace();
   }
   
   try{
       bw.close();
   }catch(Exception e){
       //pass
   }
   showVels(xf,yf,vxf,vyf,nspeck);

  }
  
  public static int mindist(int n, int tt, double[] x, double[] y, int[] t, double[][] rad){
    // i is the index of the speckle whose distance we want (x,y is apeckle coords over time)
    // n is the number of frames speckle occues
    // calculates the distance to the snake
    int ji=0;
    int prnt=0;
    double x1=0.0,x2=0.0,x3=0.0;
    double y1=0.0,y2=0.0,y3=0.0;
    double dx=0.0,dy=0.0,mind=500.0;
    double b=0.0,c=0.0,m=0.0;
    double rxy = 0;
    double rx = 0;
    double ry = 0;
    double rt=0.0, rt2=0.0, rxt=0.0, ryt=0.0;
    double mx=0.0,my=0.0,bx=0.0,by=0.0;
    double rx2 = 0.0;
    double sx=0.0, sy=0.0;
    double th=0.0;
    double ddist=0.0;
    int bth=0;
    
    for(int zz=0;zz<n;zz++)
    {
      rx += x[zz];
      ry += y[zz];
      rt += t[zz];
      rt2 += t[zz]*t[zz];
      rxt += x[zz]*t[zz];
      ryt += y[zz]*t[zz];
    }
    
    rx /= n;
    rt /= n;
    ry /= n;
    rxt /= n;
    rt2 /= n;
    ryt /= n;
    
    // linear fit of our speckle trail
    mx = (rxt-rx*rt)/(rt2-rt*rt);
    bx = (rx-mx*rt);
    my = (ryt-ry*rt)/(rt2-rt*rt);
    by = (ry-my*rt);
    
    for(int ki=(int)bot;ki<(int)top;ki++)
    {
      th = (Speckle_Velocity.pi)*ki/180;
      sx = rad[tt][ki] * Math.cos(th);
      sy = rad[tt][ki] * Math.sin(th);
      // get closest point on the vr line to this point
      dx = sx-(mx*t[0]+bx);
      dy = sy-(my*t[0]+by);
      ddist = Math.sqrt(dy*dy+dx*dx);
      
      if(ddist<mind){
        ji=ki; // pt that is closest to our vector
        mind = ddist;
        x2 = sx;
        y2 = sy;
      }
    }
    
    sx = mx*t[0] + bx;
    sy = my*t[0] + by;
    
    dx = x2-sx;
    dy = y2-sy;
    
    Speckle_Velocity.dist = Math.sqrt(dx*dx+dy*dy);
    
    return ji;
  }
  
  
  public void showVels(double [][] xf, double [][] yf, double [][] vxf, double vyf [][], int nspeck[])
  {
	  ImageStack istack = implus.getStack();
      ImageStack outstack = new ImageStack(implus.getWidth(), implus.getHeight());
      for(int i = 1; i<=istack.getSize(); i++){ // i is the frame number
                          // duplicate the stack
    	 int ji = i-1;
          ImageProcessor ip = istack.getProcessor(i).convertToRGB().duplicate();
          ip.setColor(55295);
          if(nspeck[ji]>0)
          {
        	  for(int ki=0; ki<nspeck[ji];ki++){ 
        		  double finalx = xf[ji][ki] + scaler*vxf[ji][ki];
        		  double finaly = yf[ji][ki] + scaler*vyf[ji][ki];
        		  
        		  double totv = Math.sqrt(vxf[ji][ki]*vxf[ji][ki]+vyf[ji][ki]*vyf[ji][ki]);
        		  double cosang = vxf[ji][ki]/totv;
        		  double sinang = vyf[ji][ki]/totv;
        		  
        		  double xe = xf[ji][ki] + (scaler*totv-5)*cosang;
        		  double ye = yf[ji][ki] + (scaler*totv-5)*sinang;
        		  
        		  double xt = xe + 3*sinang;//rhs arrow
        		  double yt = ye - 3*cosang;//rhs arrow
        		  
        		  double xb = xe - 3*sinang;
        		  double yb = ye + 3*cosang;
        		
        		  ip.drawLine((int)xf[ji][ki], (int)yf[ji][ki], (int)finalx, (int)finaly);
        		  ip.drawLine((int)finalx, (int)finaly, (int)xt, (int)yt);
        		  ip.drawLine((int)finalx, (int)finaly, (int)xb, (int)yb);
        	
          		}

              
          }

          outstack.addSlice("next", ip);
      }
          ImagePlus x = new ImagePlus("velocities",outstack);
          x.show();
  }
}