import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.measure.*;
import ij.plugin.TextReader;
import java.io.File;
import java.lang.*;
import ij.io.*;
import ij.ImagePlus;
import ij.ImageStack;
import ij.gui.GenericDialog;
import ij.gui.Plot;
import ij.plugin.filter.PlugInFilter;
import ij.process.Blitter;
import ij.process.FloatProcessor;
import ij.process.ImageProcessor;
import snakeprogram.MultipleSnakesStore;
import snakeprogram.Snake;
import snakeprogram.SnakeIO;

import java.awt.*;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;

import java.io.*;
import java.util.*;
import java.lang.Math;
import java.text.*;

public class Speckle_Velocity_Nosnakes implements PlugInFilter
{
  ImagePlus implus;
  double LINE_WIDTH;
  public static double dt;
  public static int tfit;
  public static int nvr;
  public static int N=0;
  public static double scaler;
    
  public static double dist = 0.0;
  public static double pi = 3.141592654;
  BufferedWriter bw;
  public int setup(String arg, ImagePlus implus) {
    this.implus = implus;
    return DOES_ALL;
  }
  
  public void run(ImageProcessor imp) 
  {
    //global variables
    double delt = 1.0; //time per frame
    double px =0.0000; //size of pixels of dx
    int tpts = 186; 
    tfit = 10;
    px=0;
    scaler = 1.0;
    GenericDialog gf = new GenericDialog("Constants");
    gf.addNumericField("dx, image resolution (nm/px): ", px,2);
    gf.addNumericField("dt, time per frame (s): ", dt, 2);
    gf.addNumericField("M, number of frames for linear fit: ", tfit, 2);
    gf.addNumericField("N, number of frames (total): ", N, 2);
    gf.addNumericField("S, scale factor for vector flow diagram: ", scaler, 2);
    gf.showDialog();
    
    if (gf.wasCanceled())
        return;
      
  
    px = (int)gf.getNextNumber();
    dt = gf.getNextNumber();
    tfit = (int)gf.getNextNumber();
    N = (int)gf.getNextNumber();
    scaler = gf.getNextNumber();

    nvr = tfit*2+1;
    double[] x = new double[N];
    double[] y = new double[N];
    int[] pts = new int[N];
    int[] t = new int[N];
    // assuming max possible 500 speckles to be considered per frame
    double xf[][]=new double[N][500];
    double yf[][]=new double[N][500];
    double vxf[][]=new double[N][500];
    double vyf[][]=new double[N][500];
    int nspeck[]=new int [N];
     
    Arrays.fill(x,0.0);
    Arrays.fill(y,0.0);
    Arrays.fill(pts,0);
    Arrays.fill(t,0);
    Arrays.fill(nspeck,0);
      
    //local variables
    int kd=0,ki=0,kk=0,ji=0,chk=0;
    int ii=0,jj=0;
    int pp=0,tt=0,f=0,p=0;
    int nfl=0, ni=0;
    int start=0;
    int numf=0;
    int[] nth = new int[400];
    int[] nd = new int[10];
    double[] vret = new double[10];
    double[] vret2 = new double[10];
    
    Arrays.fill(nth,0);
    Arrays.fill(nd,0);
    Arrays.fill(vret,0.0);
    Arrays.fill(vret2,0.0);
    
    int h = 2000;
    int w = 2000;
    int l = 2;
    int thS=0;
    double stime=0.0,z=0.0;
    double x1=0.0,x2=0.0,y1=0.0,y2=0.0;
    double distb = 0.0;
    double delx=0.0, dely=0.0, r=0.0, velr=0.0,velt=0.0;
    double velx, vely;
    double rx=0.0,rx2=0.0,ry=0.0,rt=0.0,rt2=0.0,rxt=0.0,ryt=0.0,ry2=0.0,mx=0.0,my=0.0,bx=0.0,by=0.0;
    double xx=0.0,yy=0.0,zz=0.0;
    double eb=0.0;
    
    //other variables
    int column = 0, row = 0;
    
    //array for storing output
    String[] output = new String[20000];
    Arrays.fill(output,"");
    int outputCount = 0; 
   
    
    int countLine = 0;
    boolean read = true;
    ji = 0;
    
    //read in the third file
    OpenDialog od = new OpenDialog("Speckle File", null);
    String dir3 = od.getDirectory() + od.getFileName();
    try
    {
      BufferedReader in = new BufferedReader(new FileReader(dir3)); //reading files in specified directory
      
      String line;
      while ((line = in.readLine()) != null) //file reading
      {
        String[] values = line.split("\t");
        for (String str : values)
        {
          if (column==0){
            if (countLine < 2 || str.equals("#%start speckle%") || str.equals("#%stop speckle%"))
              read = false;
            else
              read = true;
            
            if (read)
              x[ji] = Double.parseDouble(str);
          }
          if (column==1 && read)
            y[ji] = Double.parseDouble(str);
          if (column==2 && read)
            t[ji] = Integer.parseInt(str);
          column++;
        }
        if (read){
          t[ji]--;
          x[ji] = x[ji];
          y[ji] = y[ji];
          ji++;
        }
        else if (!read && ji!= 0){ // do analysis
          ki++;

            if(ji >= nvr){
              kk = ji;
              start = tfit;
              while(kk-nvr >= 0){
                ii = tfit;
                rt = 0;
                rt2 = 0;
                ry = 0;
                ryt = 0;
                rx = 0;
                rxt = 0;
                int nnn = 0;
                for(int i=start-ii;i<start+ii;i++)
                {
                  // sum up values for the averages
                  nnn++;
                  rt += t[i];
                  ry += y[i];
                  rx += x[i];
                  rt2 += t[i]*t[i];
                  rxt += x[i]*t[i];
                  ryt += y[i]*t[i];
                }
                
                //take average
                rt /= nnn;
                rx /= nnn;
                ry /= nnn;
                rt2 /= nnn;
                rxt /= nnn;
                ryt /= nnn;
                
                // calculate linear slope and intercepts for both x and y
                mx = (rxt-rx*rt)/(rt2-rt*rt);
                bx = rx-mx*rt;
                
                my = (ryt-ry*rt)/(rt2-rt*rt);
                by = ry-my*rt;
                
                // calculate x velocity
                x1 = mx*t[start-ii]+bx;
                x2 = mx*t[start+ii-1]+bx;
                delx = x2-x1;
                
                // calculate y velocity
                y1 = my*t[start-ii]+by;
                y2 = my*t[start+ii-1]+by;
                dely = y2-y1;
                
                // calculate total velocity 
                velx = delx*px/(dt*(t[start+ii-1]-t[start-ii]));
                vely = dely*px/(dt*(t[start+ii-1]-t[start-ii]));
                velt = Math.sqrt(velx*velx+vely*vely);
                
                ii = t[start];
                DecimalFormat df = new DecimalFormat("0.000000");
                output[outputCount] = " "+ki+" "+ ii +" " + ji*dt + " " + df.format(velt)+" "+df.format(velx)+" "+df.format(vely);
                outputCount++;
                
                jj = nspeck[ii];// number of speckles with velocities in this frame
                xf[ii][jj] = x[start];
                yf[ii][jj] = y[start];
                vxf[ii][jj] = velx;
                vyf[ii][jj] = vely;
                nspeck[ii]++;
                
                kk--;
                start++;
              }
            }
          
          ji = 0;
        }
        column = 0;
        countLine++;
      }
      in.close();
    }catch( IOException ioException ) {}
    
    //write result file
    try{
        FileDialog fd = new FileDialog(ij.IJ.getInstance(),"Save Speckle File",FileDialog.SAVE);
        fd.setFile("SpeckleOutput.txt");
        fd.setVisible(true);
        String fname = fd.getFile();
        String dirname = fd.getDirectory();
        String outname = dirname +  fname;
     
        
        File file = new File(outname);
        FileWriter file_writer = new FileWriter (file);
        BufferedWriter buf_writer = new BufferedWriter (file_writer);
        PrintWriter print_writer = new PrintWriter (buf_writer,true);
        
        
        
        for(int i=0;i<20000;i++){
            if(!output[i].isEmpty()) print_writer.println(output[i]);
          }
      
        }catch(Exception e){
            System.out.println("problems");
           e.printStackTrace();
       }
       
       try{
           bw.close();
       }catch(Exception e){
           //pass
       }
       
       showVels(xf,yf,vxf,vyf,nspeck);
}
  public void showVels(double [][] xf, double [][] yf, double [][] vxf, double vyf [][], int nspeck[])
  {
	  ImageStack istack = implus.getStack();
      ImageStack outstack = new ImageStack(implus.getWidth(), implus.getHeight());
      for(int i = 1; i<=istack.getSize(); i++){ // i is the frame number
                          // duplicate the stack
    	  int ji=i-1;
          ImageProcessor ip = istack.getProcessor(i).convertToRGB().duplicate();
          ip.setColor(55295);
          if(nspeck[ji]>0)
          {
        	  for(int ki=0; ki<nspeck[ji];ki++){ 
        		  double finalx = xf[ji][ki] + scaler*vxf[ji][ki];
        		  double finaly = yf[ji][ki] + scaler*vyf[ji][ki];
        		  
        		  double totv = Math.sqrt(vxf[ji][ki]*vxf[ji][ki]+vyf[ji][ki]*vyf[ji][ki]);
        		  double cosang = vxf[ji][ki]/totv;
        		  double sinang = vyf[ji][ki]/totv;
        		  
        		  double xe = xf[ji][ki] + (scaler*totv-5)*cosang;
        		  double ye = yf[ji][ki] + (scaler*totv-5)*sinang;
        		  
        		  double xt = xe + 3*sinang;//rhs arrow
        		  double yt = ye - 3*cosang;//rhs arrow
        		  
        		  double xb = xe - 3*sinang;
        		  double yb = ye + 3*cosang;
        		
        		  ip.drawLine((int)xf[ji][ki], (int)yf[ji][ki], (int)finalx, (int)finaly);
        		  ip.drawLine((int)finalx, (int)finaly, (int)xt, (int)yt);
        		  ip.drawLine((int)finalx, (int)finaly, (int)xb, (int)yb);
        	
          		}
        	 
              
          }
 
          outstack.addSlice("next", ip);
      }
          ImagePlus x = new ImagePlus("velocities",outstack);
          x.show();
      
  }
  
  
}